"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _List = _interopRequireDefault(require("@mui/material/List"));

var _Divider = _interopRequireDefault(require("@mui/material/Divider"));

var _CommentModel = _interopRequireDefault(require("../Comment/CommentModel"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var CommentList = function CommentList(props) {
  return /*#__PURE__*/_react["default"].createElement(_List["default"], {
    sx: {
      width: '100%',
      maxWidth: 360,
      bgcolor: 'background.paper'
    }
  }, props.comments.sort(function (commentA, commentB) {
    return new Date(commentB.createdAt) - new Date(commentA.createdAt);
  }).map(function (_comment) {
    var model = props.commentModel ? new props.commentModel(_comment) : new _CommentModel["default"](_comment);
    return /*#__PURE__*/_react["default"].createElement("div", {
      key: _comment.id
    }, model.paint(props), /*#__PURE__*/_react["default"].createElement(_Divider["default"], {
      variant: "inset",
      component: "li"
    }));
  }));
};

var _default = CommentList;
exports["default"] = _default;